[changes]
* Alpha-numeric sorting is now available for interactive sorting as well.
* Login type "Database Authentication" added - use a database's authentication as an authentication method.
* New warnings in case of null-check by =null and in case of confusion of = and := in Crystal-Syntax added.
* Corporate Design guide added to the documentation.
* Grouped Summary fields are now an error in the record selection formula since their value is undefined while filtering. Use them in the group selection instead.
* Performance and stability improvements for reports with massive formula dependencies.
*  When PostgreSQL database is used and the quotesToLowerCase (Quote Database Identifier) property is set in datasource configuration, database identifiers are always quoted.

#### API modifications
* Added Classes:
  * AuthenticationProvider
  * RemoteWebUserInfo
  * WebUserInfo
* Added Methods:
  * BarPlot.getBarMarginPercent()
  * BarPlot.setBarMarginPercent( double )
  * CrossTabBody.moveSummaryField(int,int)
* The method signature of DesignerDataModel.openPropertyFormulaDialog changed. Now a property name and a flag to indicate a tristate is necessary. 

### Java report viewer
* It is now possible to switch between the prompts in the parameter request dialog using Ctrl+Alt+P and Ctrl+Alt+N.

### HTML report viewer
* A color picker for the background color of image export formats (only certain browsers) added.
* The image export now supports RGB hex values as background colors (you have to properly encode the parameter).
* Button to enable/disable promptonrefresh while displaying the report with prompt parameters added to the toolbar. It can be removed by using the report URL parameter "haspromptonrefresh=false".
* Help tooltips added to the export dialog properties.
* The report URL property "defaultzoom" is supported.

### i-net Designer
* 'Default Author' button added to category Summary in the Document Properties dialog. 
* Sort option to sort string fields by their alpha numeric value added to the Sort Records dialog.
* Chart Properties: Property "Bar Spacing" added to the category "Plot Specific" of a bar chart.
* Group Properties: Alpha-Numeric sorting of STRING fields can now be used for groups as well.
* API method EmbeddedUtils.getSelectedEngine() added. It returns the current selected engine of the report. It may differ from getCurrentEngine, if a subreport is selected.

### Remote Interface
* The upload file dialog in the Repository Browser was optimized.
* Statistics data are now stored in a Zip file to reduce disk space.
* Remote statistics now have an option to set the maximum amount of data sets to load in order to keep the application responsive and smooth, especially useful for mobile clients.
* Page 'Connection Pool' showing current database connections added to the statistics module.
* The available groups and user will be displayed in the user/role drop down list in configuration manager categories system and report permissions if authentication type LDAP is used.

### Ad Hoc Reporting
* Excluding filter criteria in Ad Hoc reporting are now concatenated by AND instead of OR.

[changes:de]
* Alphanumerische Sortierung ist jetzt auch für die interaktive Sortierung verfügbar.
* Login-Typ "Datenbank-Authentifizierung" hinzugefügt - verwenden Sie die Authentifizierung einer Datenbank als Authentifizierungsmethode.
* Neue Warnungen bei der Null-Prüfung durch =null und bei der Verwechslung von = und := in Crystal-Syntax hinzugefügt.
* Corporate Design Leitfaden zur Dokumentation hinzugefügt.
* Gruppierte Zusammenfassungsfelder sind jetzt ein Fehler in der Datensatzauswahlformel, da ihr Wert beim Filtern undefiniert ist. Verwenden Sie sie stattdessen in der Gruppenauswahl.
* Performance- und Stabilitätsverbesserungen für Berichte mit massiven Formelabhängigkeiten.
*  Wenn die PostgreSQL-Datenbank verwendet wird und die Eigenschaft quotesToLowerCase (Quote Database Identifier) in der Datenquellenkonfiguration eingestellt ist, werden Datenbankbezeichner immer in Anführungszeichen gesetzt.

#### API-Änderungen
* Klassen hinzugefügt:
  * AuthenticationProvider
  * RemoteWebUserInfo
  * WebUserInfo
* Hinzugefügte Methoden:
  * BarPlot.getBarMarginPercent()
  * BarPlot.setBarMarginPercent( double )
  * CrossTabBody.moveSummaryField(int,int)
* Die Methodensignatur von DesignerDataModel.openPropertyFormulaDialog wurde geändert. Jetzt ist ein Eigenschaftsname und ein Flag zur Angabe eines Tristates notwendig.

### Java Report Viewer
* Es ist nun möglich, mit Strg+Alt+P und Strg+Alt+N zwischen den Eingabeaufforderungen im Parameterabfragedialog zu wechseln.

### HTML-Berichtsbetrachter
* Ein Farbwähler für die Hintergrundfarbe von Bildexportformaten (nur bestimmte Browser) wurde hinzugefügt.
* Der Bildexport unterstützt jetzt RGB-Hex-Werte als Hintergrundfarben (Sie müssen den Parameter richtig kodieren).
* Die Schaltfläche zum Aktivieren/Deaktivieren von Promptonrefresh während der Anzeige des Berichts mit Prompt-Parametern wurde der Symbolleiste hinzugefügt. Sie kann mit dem URL-Parameter des Berichts "haspromptonrefresh=false" entfernt werden.
* Die Eigenschaften des Exportdialogs wurden um Hilfe-Tooltips ergänzt.
* Die Bericht-URL-Eigenschaft "defaultzoom" wird unterstützt.

### i-net Designer
* die Schaltfläche "Standardautor" wurde zur Kategorie "Zusammenfassung" im Dialog "Dokumenteigenschaften" hinzugefügt.
* Sortieroption zum Sortieren von String-Feldern nach ihrem alphanumerischen Wert zum Dialogfeld "Datensätze sortieren" hinzugefügt.
* Diagramm-Eigenschaften: Eigenschaft "Balkenabstand" zur Kategorie "Plot Specific" eines Balkendiagramms hinzugefügt.
* Gruppeneigenschaften: Alphanumerische Sortierung von STRING-Feldern kann jetzt auch für Gruppen verwendet werden.
* API-Methode EmbeddedUtils.getSelectedEngine() hinzugefügt. Sie gibt die aktuell ausgewählte Engine des Berichts zurück. Sie kann sich von getCurrentEngine unterscheiden, wenn ein Subreport ausgewählt ist.

### Remote Schnittstelle
* Der Datei-Upload-Dialog im Repository Browser wurde optimiert.
* Die Statistikdaten werden jetzt in einer Zip-Datei gespeichert, um Speicherplatz zu sparen.
* Die Remote-Statistiken verfügen nun über eine Option zum Einstellen der maximalen Anzahl der zu ladenden Datensätze, um die Anwendung reaktionsschnell und reibungslos zu halten, was insbesondere für mobile Clients nützlich ist.
* Die Seite 'Connection Pool', die die aktuellen Datenbankverbindungen anzeigt, wurde dem Statistikmodul hinzugefügt.
* Die verfügbaren Gruppen und Benutzer werden in der Benutzer/Rollen-Dropdown-Liste in den Konfigurationsmanager-Kategorien System- und Berichtsberechtigungen angezeigt, wenn der Authentifizierungstyp LDAP verwendet wird.

### Ad-hoc-Berichterstattung
* Ausschließende Filterkriterien im Ad Hoc Reporting werden nun mit AND statt OR verknüpft.

[bugfixes]
* PDF export:
  * A blank subreport with enabled "Suppress if Blank" property could hide the following data.
  * A blank subreport with enabled "Suppress if Blank" property could create an empty page.
* Excel export: Cell distribution property was not used in subreports.
* HTML export: If the property "Multiple HTML files" is disabled then only the first page of a multi-page report was displayed in the browser.
* Charts:
  * Bug with StackedBarCharts occured. It caused the total sum to appear only if the last or before-last series has a value in that column. 
* ReportServletJSP restored.
* The i-net Clear Reports plugins were not loaded correctly if deployed in Tomcat 8.0.11.
* Unicode problems occurred if the codepage of the Java VM was different to the codepage of the platform.
* Restoring of Unicode data from the harddisk cache and database cache was wrong. 
* HTML prompt dialog:
  * It did not open up for exporting a report in cases when a report contained a date range prompt with range default values.
  * Time prompts were not correctly handled.
  * Time prompts were not correctly checked for their limits if they had limits for allowed values.
  * If more than one sub-report had a prompt with the same prompt name, the HTML prompt dialog only set the value of the prompt from the first sub-report, causing the prompt dialog to re-appear when hitting Submit.
  * URL parameters setting prompt values were not always used correctly for setting up chosen values.
  * Date range values which included a limit for allowed values were not always correctly checked for the limit.
  * If a date prompt was set to "default values only", it still displayed a calendar button for choosing a date.
  * If a value was missing, then cascading sub-prompts were not correctly selected in the prompt tree in the HTML prompt dialog.
* Database field and dynamic prompt field values with type CHAR or NCHAR were not truncated.
* PDF form fields did not work correctly in subreports.
* HTML export:
  * Representation of developer edition labels was incorrect.
  * Page content was moved to the right side of the page, after an subreport.
* NullPointerException in MemoryStream.writeUTF8(SourceFile:196) occurred.
* Exception: "Protocol is not file: jndi:...rpt" occurred in a formula.
* CurrentDate formula function has returned the current time as hidden value. If it was used for the calculation, then it could lead to false results.
* Regression: If a report renders longer than 10 minutes an error message "Wrong Mime Type text/html" has occurred, if the Java report viewer was used.
* The "round" formula function has not always used ROUND_HALF_UP like documented.
* In very rare cases the multiplication of large numbers or numbers with a large scale returns a wrong result.
* Data export:
  * Suppressed fields were not refreshed.
* Special Field and formula function "ReportFile" has returned absolute report file URL. In case of http URL it returns the relative URL again.
*  Formula function "truncate" has returned incorrect value because of internal rounding error.
* NegativeArraySizeException occurred while parsing an BMP image. BMP images with top down line order now supported.
* The following exception occurred if a certificate with IBM JavaVM was used: java.security.NoSuchAlgorithmException: SunX509 KeyManagerFactory not available.
* XLS export:
  * Some different strings could not be distinguished, therefore instead of two different strings the same string was added two times to the XLS file.
* Unhandled Exception "java.lang.InternalError" with message "couldn't create component peer" occurred with Java 8u152.
* Sometimes NullPointerException could occur after the 10 minutes timeout of the web API has occurred.

### Java report viewer
* If the Java report viewer was running at least with Java 7u65, then the printer properties dialog was not displayed after a click on the properties button in the print dialog.

### HTML report viewer
* Depending on the used browser, one of the following errors has occurred: "TypeError: k.elementStyle is not a function" or "Object doesn't support property or method 'elementStyle'".

### i-net Designer
* License exception with Report Data datasource occurred.
* "Report file not found" exception occurred in Database Wizard when Report Data datasource was used.
* Remote Designer: Deadlock with local saved reports could occur.
* Authentication exception occurred, if the current user does not have the right to access a report from repository. A login box will now be displayed.
* Empty binary prompts caused the report browser to hang.
* The formatting functions CURRENTFIELDVALUE and DEFAULTATTRIBUTE were not displayed in the tree on the right side of the Formula Editor. They will be displayed if the current formula is a property formula.
* Visual Database Wizard never used the set connection from LoginDatabase.
* If the i-net Designer was running on Mac OSX and the Formula Editor was opened with the "New" button in the fields browser then it was sometimes not possible to edit formulas in the Formula Editor.
* SQLException: "Method not supported from this layout driver" occurred if LayoutDatasource was used to create ad hoc reporting template in i-net Designer.
* If Nimbus look&feel was used and the i-net Designer was running with Java 8 then selected tree nodes disappeared on selection.
* The key of the translated text defined with formula function "TranslateFixed" was not listed in the Language Editor.

### Ad Hoc Reporting
* If a dataview name contains space(s) and it was saved in a database repository, then it was not available in Ad Hoc reporting.
* Loading issue on remote Ad Hoc filter page occurred. If the same Ad Hoc report was loaded with different filter values, only the first filter value was used.
* Ad Hoc reporting applet could not use ad hoc dataview if an database repository was used.
* The following exception has occurred, if cascading prompts were used in Ad Hoc reporting: NoClassDefFoundError: com/google/gwt/user/server/rpc/RemoteServiceServlet.

### .Net Edition
* IKVM updated to version 7.4.

[bugfixes:de]
* PDF-Export:
  * Ein leerer Unterbericht mit aktivierter "Suppress if Blank"-Eigenschaft konnte die folgenden Daten verbergen.
  * Ein leerer Teilbericht mit aktivierter Eigenschaft "Unterdrücken, wenn leer" könnte eine leere Seite erzeugen.
* Excel-Export: Die Eigenschaft Zellverteilung wurde in Unterberichten nicht verwendet.
* HTML-Export: Wenn die Eigenschaft "Mehrere HTML-Dateien" deaktiviert ist, wurde nur die erste Seite eines mehrseitigen Berichts im Browser angezeigt.
* Diagramme:
  * Es trat ein Fehler mit StackedBarCharts auf. Er führte dazu, dass die Gesamtsumme nur dann angezeigt wurde, wenn die letzte oder vorletzte Reihe einen Wert in dieser Spalte hatte.
* ReportServletJSP wiederhergestellt.
* Die i-net Clear Reports Plugins wurden nicht korrekt geladen, wenn sie in Tomcat 8.0.11 eingesetzt wurden.
* Unicode-Probleme traten auf, wenn die Codepage der Java VM nicht mit der Codepage der Plattform übereinstimmte.
* Die Wiederherstellung von Unicode-Daten aus dem Festplatten-Cache und dem Datenbank-Cache war falsch.
* HTML-Eingabeaufforderung:
  * Er öffnete sich beim Exportieren eines Berichts nicht, wenn der Bericht eine Datumsbereichsabfrage mit Bereichsvorgaben enthielt.
  * Zeitabfragen wurden nicht korrekt gehandhabt.
  * Zeitabfragen wurden nicht korrekt auf ihre Grenzen geprüft, wenn sie Grenzen für zulässige Werte hatten.
  * Wenn mehr als ein Unterbericht eine Eingabeaufforderung mit demselben Eingabeaufforderungsnamen enthielt, setzte der HTML-Eingabeaufforderungsdialog nur den Wert der Eingabeaufforderung aus dem ersten Unterbericht, was dazu führte, dass der Eingabeaufforderungsdialog erneut angezeigt wurde, wenn man auf Senden drückte.
  * URL-Parameter, die Prompt-Werte setzen, wurden nicht immer korrekt für die Einstellung der gewählten Werte verwendet.
  * Datumsbereichswerte, die einen Grenzwert für zulässige Werte enthielten, wurden nicht immer korrekt auf den Grenzwert geprüft.
  * Wenn eine Datumsabfrage auf "nur Standardwerte" eingestellt war, wurde trotzdem eine Kalenderschaltfläche zur Auswahl eines Datums angezeigt.
  * Wenn ein Wert fehlte, wurden kaskadierende Unterprompts im Prompt-Baum im HTML-Prompt-Dialog nicht korrekt ausgewählt.
* Werte von Datenbankfeldern und dynamischen Eingabeaufforderungsfeldern mit dem Typ CHAR oder NCHAR wurden nicht abgeschnitten.
* PDF-Formularfelder funktionierten in Teilberichten nicht korrekt.
* HTML-Export:
  * Die Darstellung der Bezeichnungen von Entwickler-Editionen war nicht korrekt.
  * Der Seiteninhalt wurde nach einem Unterbericht an den rechten Rand der Seite verschoben.
* NullPointerException in MemoryStream.writeUTF8(SourceFile:196) aufgetreten.
* Exception: "Protokoll ist keine Datei: jndi:...rpt" trat in einer Formel auf.
* Die Formelfunktion CurrentDate hat die aktuelle Zeit als versteckten Wert zurückgegeben. Wenn sie für die Berechnung verwendet wurde, konnte dies zu falschen Ergebnissen führen.
* Regression: Wenn ein Bericht länger als 10 Minuten gerendert wird, trat eine Fehlermeldung "Wrong Mime Type text/html" auf, wenn der Java Report Viewer verwendet wurde.
* Die Formelfunktion "Runden" hat nicht immer wie dokumentiert ROUND_HALF_UP verwendet.
* In sehr seltenen Fällen liefert die Multiplikation von großen Zahlen oder Zahlen mit einer großen Skala ein falsches Ergebnis.
* Datenexport:
  * Unterdrückte Felder wurden nicht aufgefrischt.
* Die spezielle Feld- und Formelfunktion "ReportFile" hat die absolute URL der Berichtsdatei zurückgegeben. Im Falle einer http-URL wird wieder die relative URL zurückgegeben.
*  Die Formelfunktion "truncate" hat aufgrund eines internen Rundungsfehlers einen falschen Wert zurückgegeben.
* NegativeArraySizeException trat beim Parsen eines BMP-Bildes auf. BMP-Bilder mit Zeilenanordnung von oben nach unten werden jetzt unterstützt.
* Die folgende Ausnahme trat auf, wenn ein Zertifikat mit IBM JavaVM verwendet wurde: java.security.NoSuchAlgorithmException: SunX509 KeyManagerFactory nicht verfügbar.
* XLS-Export:
  * Einige unterschiedliche Zeichenketten konnten nicht unterschieden werden, daher wurde statt zweier unterschiedlicher Zeichenketten die gleiche Zeichenkette zweimal in die XLS-Datei eingefügt.
* Unbehandelte Exception "java.lang.InternalError" mit der Meldung "couldn't create component peer" trat bei Java 8u152 auf.
* Manchmal konnte eine NullPointerException auftreten, nachdem der 10-Minuten-Timeout der Web-API eingetreten war.

### Java-Berichtsbetrachter
* Wenn der Java Report Viewer mindestens mit Java 7u65 lief, wurde der Druckereigenschaften-Dialog nach einem Klick auf die Eigenschaften-Schaltfläche im Druckdialog nicht angezeigt.

### HTML-Berichtsbetrachter
* Je nach verwendetem Browser ist einer der folgenden Fehler aufgetreten: "TypeError: k.elementStyle is not a function" oder "Object doesn't support property or method 'elementStyle'".

### i-net Designer
* Es ist eine Lizenzausnahme mit der Datenquelle Report Data aufgetreten.
* die Ausnahme "Report file not found" trat im Datenbank-Assistenten auf, wenn die Datenquelle "Report Data" verwendet wurde.
* Ferngesteuerter Designer: Deadlock mit lokal gespeicherten Berichten konnte auftreten.
* Es trat eine Authentifizierungsausnahme auf, wenn der aktuelle Benutzer nicht das Recht hat, auf einen Bericht aus dem Repository zuzugreifen. Es wird nun ein Anmeldefeld angezeigt.
* Leere binäre Eingabeaufforderungen führten dazu, dass der Berichtsbrowser hängen blieb.
* Die Formatierungsfunktionen CURRENTFIELDVALUE und DEFAULTATTRIBUTE wurden nicht in der Baumstruktur auf der rechten Seite des Formeleditors angezeigt. Sie werden angezeigt, wenn die aktuelle Formel eine Eigenschaftsformel ist.
* Der Visual Database Wizard hat nie die eingestellte Verbindung von LoginDatabase verwendet.
* Wenn der i-net Designer unter Mac OSX ausgeführt wurde und der Formeleditor mit der Schaltfläche "Neu" im Feldbrowser geöffnet wurde, war es manchmal nicht möglich, Formeln im Formeleditor zu bearbeiten.
* SQLException: "Method not supported from this layout driver" trat auf, wenn LayoutDatasource verwendet wurde, um eine Ad-hoc-Berichtsvorlage im i-net Designer zu erstellen.
* Wenn Nimbus look&feel verwendet wurde und der i-net Designer mit Java 8 lief, verschwanden ausgewählte Baumknoten bei der Auswahl.
* Der Schlüssel des übersetzten Textes, der mit der Formelfunktion "TranslateFixed" definiert wurde, wurde im Spracheditor nicht angezeigt.

### Ad Hoc Reporting
* Wenn ein Dataview-Name Leerzeichen enthält und in einem Datenbank-Repository gespeichert wurde, war er im Ad Hoc Reporting nicht verfügbar.
* Es trat ein Ladeproblem auf einer entfernten Ad Hoc-Filterseite auf. Wenn derselbe Ad Hoc-Bericht mit verschiedenen Filterwerten geladen wurde, wurde nur der erste Filterwert verwendet.
* Das Ad-Hoc-Berichtsapplet konnte die Ad-Hoc-Datenansicht nicht verwenden, wenn ein Datenbank-Repository verwendet wurde.
* Die folgende Ausnahme ist aufgetreten, wenn kaskadierende Prompts im Ad Hoc Reporting verwendet wurden: NoClassDefFoundError: com/google/gwt/user/server/rpc/RemoteServiceServlet.

### .Net Edition
* IKVM wurde auf Version 7.4 aktualisiert.

[security]

[security:de]
